LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;


ENTITY myram32x4 IS
	PORT
	(
		address		: IN STD_LOGIC_VECTOR (4 DOWNTO 0);
		clock		: IN STD_LOGIC  := '1';
		data		: IN STD_LOGIC_VECTOR (3 DOWNTO 0);
		wren		: IN STD_LOGIC ;
		q		: OUT STD_LOGIC_VECTOR (3 DOWNTO 0)
	);
END;


ARCHITECTURE behavioural OF myram32x4 IS

	TYPE mem IS ARRAY(0 TO 31) OF STD_LOGIC_VECTOR(3 DOWNTO 0);
	SIGNAL memory_array : mem;
	SIGNAL address_reg : STD_LOGIC_VECTOR (4 DOWNTO 0);

BEGIN

	process(clock)
	begin
		if rising_edge(clock) then
			address_reg<= address;
			if (wren='1') then
				memory_array(to_integer(unsigned(address)))<=data;
			end if;
		end if;
	end process;

	q<=memory_array(to_integer(unsigned(address_reg)));

END ARCHITECTURE;
		